<?php
/*
This is the script which outputs the model file representing a BitTorrent swarm(.pm).
*/
?>
mdp

module simple

<?php


require 'common.php';




/*--------------- PRISM VARIABLE LISTS --------------------*/

function writeGlobalVariables() {
global $NO_AGENT, $NUM_NORMAL_AGENTS, $ATTACKER, $SEEDER,
		$MAX_WORK, $NUM_PIECES, $NUM_BLOCKS, $TOTAL_NUM_AGENTS, $MAX_PIECE, $MAX_BLOCK;
	echo "// to keep track of whose turn it is. It's your turn if the variable is equal to your AgentID"; newl();
	echo turnVar()." : [0..{$ATTACKER}] init 0;"; newl();
	$numTasks = 0;
	for($i = 0; $i<$TOTAL_NUM_AGENTS; $i++) {
		$numTasks = max($numTasks,count(getAgentTasks($i)));
	}
	echo counterVar()." : [0..{$numTasks}] init 0;"; newl();
	
	
	newl();
}

function writeAgentVariables($agentID, $isSeeder) {
	global $NO_AGENT, $NUM_NORMAL_AGENTS, $ATTACKER, $SEEDER,
		$MAX_WORK, $NUM_PIECES, $NUM_BLOCKS, $TOTAL_NUM_AGENTS, $MAX_PIECE, $MAX_BLOCK;

	
	echo "// --- Variables for Agent: {$agentID} --- "; newl(); newl();
	echo workVar($agentID)." : [0..{$MAX_WORK}] init 0;"; newl();
	echo justDownloadedPieceVar($agentID)." : [-1..{$MAX_PIECE}] init -1;"; newl(); newl();
	
	
	// own variables (not dependent on other agents)
	for($p = 0; $p < $NUM_PIECES; $p++) {	
		echo justDownloadedBlockVar($agentID, $p)." : [-1..{$MAX_BLOCK}] init -1;"; newl(); 
	
		echo pieceStatusVar($agentID, $p)." : [0..1] init ";
		if ($isSeeder) echo "1;";
		else echo "0;";
		newl();
		for($l = 0; $l < $NUM_BLOCKS; $l++) {
		
			echo blockStatusVar($agentID, $p, $l)." : [0..2] init ";
			if ($isSeeder) echo "1;";
			else echo "0;";
			newl();
			echo blockStatusPortVar($agentID, $p, $l)." : [0..2] init 0;"; newl();
			echo reqFromVar($agentID, $p, $l).
				": [-1..{$TOTAL_NUM_AGENTS}] init {$NO_AGENT};"; newl();
		} 
		newl();
	}
	
	// variables dependent on other agents
	for($other = 0; $other < $TOTAL_NUM_AGENTS; $other++) {
		if($other != $agentID && ($isSeeder || $other != $SEEDER)) {
			echo "// Agent1: {$agentID}, Agent2: {$other}"; newl(); newl();
		
			echo isChokedVar($agentID, $other)." : bool init true;"; newl();
			echo isInterestedInVar($agentID, $other)." : bool init false;"; newl();
			echo isChokingVar($agentID, $other)." : bool init true;"; newl();
			echo thinksInterestedVar($agentID, $other)." : bool init "; 
			if($isSeeder) echo "true";
			else echo "false";
			echo ";";newl();
			echo thinksInterestedPortVar($agentID, $other)." : [-1..1] init -1;"; newl();
			newl();
			for($p = 0; $p < $NUM_PIECES; $p++) {
				echo thinksHasPieceVar($agentID, $other, $p)." : bool init false;"; newl();
				echo thinksHasPiecePortVar($agentID, $other, $p)." : bool init false;"; newl();
				for($l = 0; $l < $NUM_BLOCKS; $l++) {
					echo isReqVar($agentID, $other, $p,$l).
						": bool init false;"; newl();
					echo isReqPortVar($agentID, $other, $p, $l).
						": bool init false;"; newl();

				}
			}
			newl();
		}
	}
	
	// special case for seeder
	if (!$isSeeder) {
		$other = $SEEDER;
		echo "// Agent1: {$agentID}, Agent2: {$other}"; newl(); newl();
		echo isChokedVar($agentID, $other)." : bool init true;"; newl();
		echo isInterestedInVar($agentID, $other)." : bool init true;"; newl();
		echo isChokingVar($agentID, $other)." : bool init true;"; newl();
		echo thinksInterestedVar($agentID, $other)." : bool init false;"; newl(); 
		echo thinksInterestedPortVar($agentID, $other)." : [-1..1] init -1;"; newl(); 
		newl();
		for($p = 0; $p < $NUM_PIECES; $p++) {
			echo thinksHasPieceVar($agentID, $other, $p)." : bool init true;"; newl();
			echo thinksHasPiecePortVar($agentID, $other, $p)." : bool init false;"; newl();
			for($l = 0; $l < $NUM_BLOCKS; $l++) {
				echo isReqVar($agentID, $other, $p,$l)." : bool init false;"; newl();
				echo isReqPortVar($agentID, $other, $p, $l).
						": bool init false;"; newl();
			}
		}
		newl();
	}
}

function writeAttackerVariables($attacker) {
	global $NO_AGENT, $NUM_NORMAL_AGENTS, $ATTACKER, $SEEDER,
		$MAX_WORK, $NUM_PIECES, $NUM_BLOCKS, $TOTAL_NUM_AGENTS;

	echo "// Attacker Variables"; newl();
	
	writeAgentVariables($ATTACKER,false);
	echo "// FINISH THIS!"; newl();

	newl();newl();
	}
	
	// ----------------------------------------------------------------------------------------------------------------- //
	
	//  JUST DOWNLOADED TRANSITIONS
	
	// HAVE MESSAGES
	
//use this as a condition before giving someone a block
function no_pending_data_condition($agent) {
	global $NO_AGENT, $NUM_NORMAL_AGENTS, $ATTACKER, $SEEDER,
		$MAX_WORK, $NUM_PIECES, $NUM_BLOCKS, $TOTAL_NUM_AGENTS;
	
	$ret = justDownloadedPieceVar($agent)."=-1 & ";
	for($p=0; $p < $NUM_PIECES; $p++) {
		$ret = $ret.justDownloadedBlockVar($agent,$p)."=-1";
		if($p<$NUM_PIECES-1) $ret = $ret . " & ";
	}
	$ret = $ret . " ";
	return $ret;
}

// generates condition that all blocks for given piece are CORRECT
function verify_condition($agent, $p) {
	global $NO_AGENT, $NUM_NORMAL_AGENTS, $ATTACKER, $SEEDER,
		$MAX_WORK, $NUM_PIECES, $NUM_BLOCKS, $TOTAL_NUM_AGENTS;
	$ret = "";
	for($l=0; $l < $NUM_BLOCKS; $l++) {
		$ret = $ret.blockStatusVar($agent,$p,$l)."=1";
		if($l < $NUM_BLOCKS - 1) $ret = $ret." & ";
	}
	return $ret;
}

// clears block statuses to 0
function clear_all_blocks_result($agent,$p) {
	global $NO_AGENT, $NUM_NORMAL_AGENTS, $ATTACKER, $SEEDER,
		$MAX_WORK, $NUM_PIECES, $NUM_BLOCKS, $TOTAL_NUM_AGENTS;
	$ret = "";
	for($l=0; $l<$NUM_BLOCKS; $l++) {
		$ret = $ret.blockStatusVar($agent,$p,$l)."'=0";
		if($l < $NUM_BLOCKS - 1) $ret = $ret . " & ";
	}
	return $ret;
}

// generates condition that all blocks for piece p are DOWNLOADED (not necessarily correctly)
function fully_downloaded($agent, $p) {
	global $NO_AGENT, $NUM_NORMAL_AGENTS, $ATTACKER, $SEEDER,
		$MAX_WORK, $NUM_PIECES, $NUM_BLOCKS, $TOTAL_NUM_AGENTS;
		$ret = "";
	for($l=0; $l < $NUM_BLOCKS; $l++) {
		$ret = $ret.blockStatusVar($agent,$p,$l).">=1";
		if($l < $NUM_BLOCKS - 1) $ret = $ret." & ";
	}
	return $ret;
}

// agent just downloaded a block for piece p
function getJustDownloadedBlockTransitions($agentID, $p) {
	global $NO_AGENT, $NUM_NORMAL_AGENTS, $ATTACKER, $SEEDER,
		$MAX_WORK, $NUM_PIECES, $NUM_BLOCKS, $TOTAL_NUM_AGENTS;
	$ret = array();
	$blockVar = justDownloadedBlockVar($agentID,$p);
	$root = new TieredTransition("{$blockVar}!=-1","{$blockVar}'=-1");
	$verified = new TieredTransition(verify_condition($agentID,$p),
		justDownloadedPieceVar($agentID)."'={$p} & ".pieceStatusVar($agentID,$p)."'=1");
	$notverified = new TieredTransition("!(".verify_condition($agentID,$p).") & ".fully_downloaded($agentID,$p),clear_all_blocks_result($agentID,$p));
	$donothing = new TieredTransition(NULL,NULL);
	$root->addChild($verified);
	$root->addChild($notverified);
	$root->addChild($donothing);
	array_push($ret,$root);
	//$root->printTransitions();
	return $ret;
}

// generates result of sending have messages
function haveMessages($agentID,$p) {
 global $NO_AGENT, $NUM_NORMAL_AGENTS, $ATTACKER, $SEEDER,
		$MAX_WORK, $NUM_PIECES, $NUM_BLOCKS, $TOTAL_NUM_AGENTS;
	$ret = "";
	for($b=0; $b<$TOTAL_NUM_AGENTS; $b++) {
		if($b!=$agentID && $b!=$SEEDER) {
			$ret = $ret.thinksHasPiecePortVar($b,$agentID,$p)."'=true";
			if($b < $TOTAL_NUM_AGENTS - 2 || $b==$TOTAL_NUM_AGENTS-2 && $agentID!= $TOTAL_NUM_AGENTS-1) $ret = $ret." & ";
		}
	}
	return $ret;
}

function getJustDownloadedPieceTransitions($agentID) {
	global $NO_AGENT, $NUM_NORMAL_AGENTS, $ATTACKER, $SEEDER,
		$MAX_WORK, $NUM_PIECES, $NUM_BLOCKS, $TOTAL_NUM_AGENTS;
	$ret = array();
	for($p=0; $p < $NUM_PIECES; $p++) {
		$trans = new TieredTransition(justDownloadedPieceVar($agentID)."={$p}", 
			justDownloadedPieceVar($agentID)."'=-1 & ".pieceStatusVar($agentID,$p)."'=1 & ".haveMessages($agentID,$p));
		array_push($ret,$trans);
	}
	return $ret;
}


function getJustDownloadedTransitions($agentID) {
	global $NO_AGENT, $NUM_NORMAL_AGENTS, $ATTACKER, $SEEDER,
		$MAX_WORK, $NUM_PIECES, $NUM_BLOCKS, $TOTAL_NUM_AGENTS;
	$ret = array();
	
	echo "// just downloaded piece transitions for agent {$agentID}"; newl();
	$ret = array_merge($ret,getJustDownloadedPieceTransitions($agentID));
	newl();
	
	echo "// just downloaded block transitions for agent {$agentID}"; newl();
	for($p=0; $p < $NUM_PIECES; $p++) {
		$ret = array_merge($ret,getJustDownloadedBlockTransitions($agentID, $p));
		newl();
	}	
	return $ret;
}

	// ----------------------------------------------------------------------------------------------------------------- //
	
	// THINKS HAS PIECE PORT TRANSITIONS
	
	function getThinksHasPiecePortTransitions($agentID) {
		global $NO_AGENT, $NUM_NORMAL_AGENTS, $ATTACKER, $SEEDER,
		$MAX_WORK, $NUM_PIECES, $NUM_BLOCKS, $TOTAL_NUM_AGENTS;
		$ret = array();
	//	echo "// thinks has piece port transitions for agent {$agentID}"; newl();
	
		for($b=0; $b<$TOTAL_NUM_AGENTS; $b++) {
			// optimized by ignoring seeder sending have messages (seeder should never need to send these, already initialized)
			if($b!=$agentID && $b!=$SEEDER) {
				for($p=0; $p < $NUM_PIECES; $p++) {
						$condition = thinksHasPiecePortVar($agentID, $b, $p) . "=true";
								//thinksHasPieceVar($agentID, $b, $p) = false;
						$consequence = thinksHasPieceVar($agentID, $b, $p) . "'=true & " .
							thinksHasPiecePortVar($agentID, $b, $p) . "'=false";
						$root = new TieredTransition($condition, $consequence);
						
						// first child
						$condition = thinksHasPieceVar($agentID, $b, $p) . "=false & " .
							pieceStatusVar($agentID, $p) . "=0";
						$consequence = isInterestedInVar($agentID, $b) . "'=true & ".
							thinksInterestedPortVar($b, $agentID) . "'=1";
						$doesntHavePieceChild = new TieredTransition($condition, $consequence);
						$root->addChild($doesntHavePieceChild);
						
						$root->addChild(new TieredTransition(NULL, NULL));
						array_push($ret,$root);
						//$root->printTransitions();
					}
			}
		}
		return $ret;
	}
	

	// ----------------------------------------------------------------------------------------------------------------- //

	

	
		// ----------------------------------------------------------------------------------------------------------------- //

	// REQUEST MESSAGES
	
//deprecated
function reset_req_action_state_vars($agentID) {
	global $NO_AGENT, $NUM_NORMAL_AGENTS, $ATTACKER, $SEEDER,
	$MAX_WORK, $NUM_PIECES, $NUM_BLOCKS, $TOTAL_NUM_AGENTS;
	
	$result = array();
	for($b=0; $b<$TOTAL_NUM_AGENTS; $b++) {
		if($b!=$agentID && $b!=$SEEDER) {
			for($p=0; $p < $NUM_PIECES; $p++) {
				for($l=0; $l < $NUM_BLOCKS; $l++) {
					array_push($result,	
						reqActionStateVar($agentID, $b, $p, $l) ."'=false");
					array_push($result,
						sendActionStateVar($agentID, $b, $p, $l) ."'=false");
				}
			}
		}
	}
	return join(" & ", $result);
}

function getRequestTransitions($agentID) {
	global $NO_AGENT, $NUM_NORMAL_AGENTS, $ATTACKER, $SEEDER,
		$MAX_WORK, $NUM_PIECES, $NUM_BLOCKS, $TOTAL_NUM_AGENTS;
	$ret = array();			
					
	for($b=0; $b<$TOTAL_NUM_AGENTS; $b++) {
		if($b!=$agentID) {
			for($p=0; $p < $NUM_PIECES; $p++) {
				for($l=0; $l < $NUM_BLOCKS; $l++) {
					$condition = 
						//reqActionStateVar($agentID, $b, $p, $l) ."=false & ".
						thinksHasPieceVar($agentID, $b, $p) . "=true & " .
						isInterestedInVar($agentID, $b)."=true &".
						blockStatusVar($agentID, $p, $l)."=0 &".
						reqFromVar($agentID, $p, $l)."=".$NO_AGENT;
					// w. prob = reqProbability
					$consequence1 =
						//reqActionStateVar($agentID, $b, $p, $l) ."'=true & ".
						reqFromVar($agentID, $p, $l)."'=".$b." & ".
						isReqPortVar($b, $agentID, $p, $l)."'=true";
					// w. prob = 1 - reqProbability
					$consequence2 = NULL;
					
					$consequence = array(
						array(reqProbability($agentID), $consequence1),
						array("1-".reqProbability($agentID), $consequence2),
					);
					$root = new TieredTransition($condition, $consequence);
						
					array_push($ret,$root);
					//$root->printTransitions();
				}
			}
		}
	}
	
	//TODO: add a probability of requesting from a new person for each block (so don't get deadlocked)
	return $ret;
}

function getProcessPendingRequestTransitions($agentID) {
	global $NO_AGENT, $NUM_NORMAL_AGENTS, $ATTACKER, $SEEDER,
		$MAX_WORK, $NUM_PIECES, $NUM_BLOCKS, $TOTAL_NUM_AGENTS;
	$ret = array();
	
	////echo "// PROCESSING PENDING REQUEST TRANSITIONS (TEST)";newl();				
					
	for($b=0; $b<$TOTAL_NUM_AGENTS; $b++) {
		if($b!=$agentID && $b!=$SEEDER) {
			for($p=0; $p < $NUM_PIECES; $p++) {
				for($l=0; $l < $NUM_BLOCKS; $l++) {
					$condition = 
						isReqPortVar($agentID, $b, $p, $l)."=true";
					$consequence = 
						isReqPortVar($agentID, $b, $p, $l)."'=false & ".
						isReqVar($agentID, $b, $p, $l)."'=true";
					
					$root = new TieredTransition($condition, $consequence);	
					array_push($ret,$root);
					//$root->printTransitions();
				}
			}
		}
	}
	return $ret;
}

function getSendBlockTransitions($agentID) {
	global $NO_AGENT, $NUM_NORMAL_AGENTS, $ATTACKER, $SEEDER,
		$MAX_WORK, $NUM_PIECES, $NUM_BLOCKS, $TOTAL_NUM_AGENTS;
	$ret = array();
	
	for($b=0; $b<$TOTAL_NUM_AGENTS; $b++) {
		if($b!=$agentID  && $b!=$SEEDER) {
			for($p=0; $p < $NUM_PIECES; $p++) {
				for($l=0; $l < $NUM_BLOCKS; $l++) {
					//TODO choking being ignored see google doc
					$condition = 
						isReqVar($agentID, $b, $p, $l)."=true & ".
						pieceStatusVar($agentID,$p)."=1 & ".
						thinksInterestedVar($agentID,$b)."=true";
						
					$consequence1 = 
						blockStatusPortVar($b, $p, $l)."'=1";
						
					$consequence2 = NULL;
						
					$consequence = array(
						array(sendProbability($agentID),$consequence1),
						array("1-".sendProbability($agentID),$consequence2)
					);
					
					$root = new TieredTransition($condition, $consequence);	
					array_push($ret,$root);
				}
			}
		}
	}
	return $ret;
	
}

function getProcessPendingBlockTransitions($agentID) {
	global $NO_AGENT, $NUM_NORMAL_AGENTS, $ATTACKER, $SEEDER,
		$MAX_WORK, $NUM_PIECES, $NUM_BLOCKS, $TOTAL_NUM_AGENTS;
	$ret = array();
	//echo "// PROCESSING PENDING BLOCK TRANSITIONS (TEST)";newl();				
					
	for($p=0; $p < $NUM_PIECES; $p++) {
		for($l=0; $l < $NUM_BLOCKS; $l++) {
			$condition = 
				blockStatusPortVar($agentID, $p, $l).">0";
			$consequence = 
				blockStatusVar($agentID, $p, $l)."'=".blockStatusPortVar($agentID, $p, $l). " & ".
				blockStatusPortVar($agentID, $p, $l)."'=0 & ".
				justDownloadedBlockVar($agentID, $p)."'={$l}";
			
			$root = new TieredTransition($condition, $consequence);	
			array_push($ret, $root);
		}
	}

	return $ret;
}

// ----------------------------------------------------------------------------------------------------------------- //

function next_turn_result($agentID) {
	global $NO_AGENT, $NUM_NORMAL_AGENTS, $ATTACKER, $SEEDER,
		$MAX_WORK, $NUM_PIECES, $NUM_BLOCKS, $TOTAL_NUM_AGENTS;
	if($agentID<$TOTAL_NUM_AGENTS-1)
		return turnVar()."'=".($agentID+1);
	else return turnVar()."'=0";
}
	
	
function getAgentTasks($agentID) {
	global $NO_AGENT, $NUM_NORMAL_AGENTS, $ATTACKER, $SEEDER,
		$MAX_WORK, $NUM_PIECES, $NUM_BLOCKS, $TOTAL_NUM_AGENTS;
	
	$all_tasks = array(); //contains all the nondeterministic tasks

	if ($agentID != $SEEDER) {
		$all_tasks = array_merge($all_tasks,getThinksHasPiecePortTransitions($agentID));
		$all_tasks = array_merge($all_tasks,getRequestTransitions($agentID));
	}
	$all_tasks = array_merge($all_tasks,getProcessPendingRequestTransitions($agentID));
	$all_tasks = array_merge($all_tasks,getSendBlockTransitions($agentID));
	if ($agentID != $SEEDER) {
		$all_tasks = array_merge($all_tasks,getProcessPendingBlockTransitions($agentID));
	}
	return $all_tasks;
}
	
function writeAgentTransitions($agentID) {
	global $NO_AGENT, $NUM_NORMAL_AGENTS, $ATTACKER, $SEEDER,
		$MAX_WORK, $NUM_PIECES, $NUM_BLOCKS, $TOTAL_NUM_AGENTS;
		
	echo "// Transitions for Agent: " . $agentID; newl(); 
	
	$root = new TieredTransition(turnVar()."={$agentID}",NULL);
	
	// note: SEEDERS don't need these JUST DOWNLOADED transitions
	
	if ($agentID != $SEEDER) {
		$justDownloaded = getJustDownloadedTransitions($agentID);
		
		foreach($justDownloaded as $task) {
			$root->addChild($task);
		}
	}
	
	$all_tasks = getAgentTasks($agentID);
	$i = 0;
	foreach($all_tasks as $task) {
		$seq_parent = new TieredTransition(counterVar()."={$i}",counterVar()."'=".($i+1));
		$seq_parent->addChild($task);
		$seq_parent->addChild(new TieredTransition(NULL,NULL));
		$root->addChild($seq_parent);
		$i++;
	}
	
	$root->addChild(new TieredTransition(NULL,next_turn_result($agentID).
		" & ".counterVar()."'=0"));
	$root->printTransitions();
	
	newl();
}

function writeAttackerTransitions($agentID) {
	global $NO_AGENT, $NUM_NORMAL_AGENTS, $ATTACKER, $SEEDER,
		$MAX_WORK, $NUM_PIECES, $NUM_BLOCKS, $TOTAL_NUM_AGENTS;
	
	$root = new TieredTransition(turnVar()."={$agentID}",next_turn_result($agentID));
	$root->printTransitions();
	
	
}

?>

<?php

echo "// no-agent: {$NO_AGENT}"; newl();
echo "// seeder: {$SEEDER}"; newl();
echo "// normal agent IDs: 1,..{$NUM_NORMAL_AGENTS}"; newl();
echo "// attacker ID: {$ATTACKER}"; newl();

?>

<?php


writeGlobalVariables();
writeAgentVariables(0,true);

for($a=1; $a<=$NUM_NORMAL_AGENTS; $a++) {
	writeAgentVariables($a,false);
}


writeAttackerVariables($ATTACKER);

for($a=0; $a<=$NUM_NORMAL_AGENTS; $a++) {
	writeAgentTransitions($a);
}

writeAttackerTransitions($ATTACKER);


?>

endmodule
